;****************************************************************************
;	nop
;****************************************************************************

(define_expand "nop"
	[(const_int 0)]
	""
	"")

;****************************************************************************
;	mov
;****************************************************************************

(define_insn "movqi"
	[(set (match_operand:QI 0 "nonimmediate_operand" "=r,r,r,m")
	      (match_operand:QI 1 "general_operand" "r,i,m,r"))]
	""
	"@
	ld.w %0, %1
	xld.w %0, %1
	xld.b %0, %1
	xld.b %0, %1")

(define_insn "movhi"
	[(set (match_operand:HI 0 "nonimmediate_operand" "=r,r,r,m")
	      (match_operand:HI 1 "general_operand" "r,i,m,r"))]
	""
	"@
	ld.w %0, %1
	xld.w %0, %1
	xld.h %0, %1
	xld.h %0, %1")

(define_insn "movsi"
	[(set (match_operand:SI 0 "nonimmediate_operand" "=r,r,r,m")
	      (match_operand:SI 1 "general_operand" "r,i,m,r"))]
	""
	"@
	ld.w %0, %1
	xld.w %0, %1
	xld.w %0, %1
	xld.w %0, %1")

;****************************************************************************
;	extend
;****************************************************************************

(define_insn "extendqisi2"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (sign_extend:SI (match_operand:QI 1 "nonimmediate_operand" "r,m")))]
	""
	"@
	ld.b %0, %1
	ld.b %0, %1")

(define_insn "extendhisi2"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (sign_extend:SI (match_operand:HI 1 "nonimmediate_operand" "r,m")))]
	""
	"@
	ld.h %0, %1
	ld.h %0, %1")

(define_insn "zero_extendqisi2"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (zero_extend:SI (match_operand:QI 1 "nonimmediate_operand" "r,m")))]
	""
	"@
	ld.ub %0, %1
	ld.ub %0, %1")

(define_insn "zero_extendhisi2"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (zero_extend:SI (match_operand:HI 1 "nonimmediate_operand" "r,m")))]
	""
	"@
	ld.uh %0, %1
	ld.uh %0, %1")

;****************************************************************************
;	add
;****************************************************************************

(define_insn "addsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (plus:SI (match_operand:SI 1 "register_operand" "0,0")
	               (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	add %0, %2
	xadd %0, %2")

;****************************************************************************
;	sub
;****************************************************************************

(define_insn "subsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (minus:SI (match_operand:SI 1 "register_operand" "0,0")
	                (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	sub %0, %2
	xsub %0, %2")

;****************************************************************************
;	mul
;****************************************************************************

(define_insn "mulhisi3"
	[(set (match_operand:SI 0 "register_operand" "=r")
	      (mult:SI (sign_extend:SI (match_operand:HI 1 "register_operand" "r"))
	               (sign_extend:SI (match_operand:HI 2 "register_operand" "r"))))]
	""
	"mlt.h %1, %2\n\tld.w %0, %%alr"
)

(define_insn "umulhisi3"
	[(set (match_operand:SI 0 "register_operand" "=r")
	      (mult:SI (zero_extend:SI (match_operand:HI 1 "register_operand" "r"))
	               (zero_extend:SI (match_operand:HI 2 "register_operand" "r"))))]
	""
	"mltu.h %1, %2\n\tld.w %0, %%alr"
)

(define_insn "mulsi3"
	[(set (match_operand:SI 0 "register_operand" "=r")
	      (mult:SI (match_operand:SI 1 "register_operand" "r")
		       (match_operand:SI 2 "register_operand" "r")))]
	""
	"mlt.w %1, %2\n\tld.w %r0, %%alr"
)

;****************************************************************************
;	div/mod
;****************************************************************************

;;֐Œ

;****************************************************************************
;	and
;****************************************************************************

(define_insn "andsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (and:SI (match_operand:SI 1 "register_operand" "0,0")
	              (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	and %0, %2
	xand %0, %2")

;****************************************************************************
;	ior
;****************************************************************************

(define_insn "iorsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (ior:SI (match_operand:SI 1 "register_operand" "0,0")
	              (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	or %0, %2
	xoor %0, %2")

;****************************************************************************
;	xor
;****************************************************************************

(define_insn "xorsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (xor:SI (match_operand:SI 1 "register_operand" "0,0")
	              (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	xor %0, %2
	xxor %0, %2")

;****************************************************************************
;	sh
;****************************************************************************

(define_insn "ashlsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (ashift:SI (match_operand:SI 1 "register_operand" "0,0")
	                 (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	xsla %0, %2
	xsla %0, %2")

(define_insn "ashrsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (ashiftrt:SI (match_operand:SI 1 "register_operand" "0,0")
	                   (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	xsra %0, %2
	xsra %0, %2")

(define_insn "lshrsi3"
	[(set (match_operand:SI 0 "register_operand" "=r,r")
	      (lshiftrt:SI (match_operand:SI 1 "register_operand" "0,0")
	                   (match_operand:SI 2 "nonmemory_operand" "r,i")))]
	""
	"@
	xsrl %0, %2
	xsrl %0, %2")

;****************************************************************************
;	neg
;****************************************************************************

(define_insn "negsi2"
	[(set (match_operand:SI 0 "register_operand" "=r")
	      (neg:SI (match_operand:SI 1 "register_operand" "r")))]
	""
	"not %0, %1\n\tadd %0, 1")

;****************************************************************************
;	cmp
;****************************************************************************

(define_insn "cmpsi"
	[(set (reg:CC 16)
	      (compare:CC (match_operand:SI 0 "register_operand" "r,r")
	                  (match_operand:SI 1 "nonmemory_operand" "r,i")))]
	""
	"@
	cmp %0, %1
	xcmp %0, %1")

;****************************************************************************
;	b
;****************************************************************************

(define_insn "beq"
	[(set (pc)
	      (if_then_else (eq (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjreq %0")

(define_insn "bne"
	[(set (pc)
	      (if_then_else (ne (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrne %0")

(define_insn "bgt"
	[(set (pc)
	      (if_then_else (gt (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrgt %0")

(define_insn "bgtu"
	[(set (pc)
	      (if_then_else (gtu (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrugt %0")

(define_insn "blt"
	[(set (pc)
	      (if_then_else (lt (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrlt %0")

(define_insn "bltu"
	[(set (pc)
	      (if_then_else (ltu (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrult %0")

(define_insn "bge"
	[(set (pc)
	      (if_then_else (ge (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrge %0")

(define_insn "bgeu"
	[(set (pc)
	      (if_then_else (geu (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjruge %0")

(define_insn "ble"
	[(set (pc)
	      (if_then_else (le (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrle %0")

(define_insn "bleu"
	[(set (pc)
	      (if_then_else (leu (reg:CC 16) (const_int 0))
	                    (label_ref (match_operand 0 "" ""))
	                    (pc)))]
	""
	"xjrule %0")

;****************************************************************************
;	call
;****************************************************************************

;Ȃb<cond>/jumpcallŔѐAhX̎w@Ⴄ̂낤H
;  call̔ѐw(label_ref (...))_Ȃ̂ȁH
;Iyh1̏ memory_operand ɂƁA-O2wȂɗ܂B
;  dȂ̂łƂ肠ȂɂĂ܂BԈĂc
;  -O2莞
;	xld.w %r1, label
;	call %1
;  -O2Ȃ̎
;	call label
;  ɂȂ݂łBiœKȂ̕ǂR[hô͂ȂHj
;xڎŵƂxcallAWX^ẑƂcallŎĝǁA
;  @킩Ȃ̂łƂ肠callɂĂ܂BȂƂB

(define_insn "call"
	[(call (match_operand 0 "" "")
	       (match_operand 1 "" ""))]
	""
	"call %0")

(define_insn "call_value"
	[(set (match_operand 0 "register_operand" "=r,r")
	      (call (match_operand 1 "" "")
	            (match_operand 2 "" "")))]
	""
	"call %1")

;****************************************************************************
;	jump
;****************************************************************************

(define_insn "jump"
	[(set (pc)
	      (label_ref (match_operand 0 "" "")))]
	""
	"xjp %0")

(define_insn "indirect_jump"
	[(set (pc)
	      (match_operand:SI 0 "register_operand" "r"))]
	""
	"xjp %0")

(define_insn "tablejump"
	[(set (pc)
	      (match_operand:SI 0 "register_operand" "r"))
              (use (label_ref (match_operand 1 "" "")))]
	""
	"xjp %0")

;****************************************************************************
;	֐v[O/Gs[O
;****************************************************************************

; ̃vZbT͑Sprologue/epiloguedefine_insnł͂Ȃdefine_expand
; `Ă܂Bdefine_insnł̓_Ȃ̂H
; Ȃ_Ȃ̂킩Ȃ̂ŁAȂ_킩邽߂ɁA
; Qo܂define_insnōsĂ݂邱Ƃɂ܂B
; define_insndefine_expand̈Ⴂ悭킩ĂȂł(^^;
; 
; _ȗR킩܂B
; define_insnƁA̕񂵂ԂȂłB
; ֐̒ŒߕтĕԂ͓̂̂ŁAemit_insnŏÂ
; ߂𐶐ɂ́Adefine_expandgKv܂B
; Ƃ킯ŁAdefine_expandɂ܂B
;
; * Gs[OR[hɂĂ͂܂I
;   c33_expand_epilogue()ɂĉ߂ȂƁA
;   RpCSEGVŗ܂B
;   ۂɂ͏ȂƂret߂KvȂ̂ővƎv܂AÔ߁B
;   v[OR[h́iKvȂ΁jłvłB

(define_expand "prologue"
	[(clobber (const_int 0))]
	""
	"{
	c33_expand_prologue();
	DONE;
	}")

(define_expand "epilogue"
	[(return)]
	""
	"{
	c33_expand_epilogue();
	DONE;
	}")

; epiloguegp
(define_insn "c33_ret"
	[(return)]
	""
	"ret")
